<?php
/**
 * Art Blog functions and definitions
 *
 * @package Art Blog
 */

if ( ! defined( 'ART_BLOG_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'ART_BLOG_VERSION', '1.0.0' );
}

function art_blog_setup() {

	load_theme_textdomain( 'art-blog', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'art-blog' ),
			'social-menu' => esc_html__('Social Menu', 'art-blog'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'art_blog_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);
    
    add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'art_blog_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $art_blog_content_width
 */
function art_blog_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'art_blog_content_width', 640 );
}
add_action( 'after_setup_theme', 'art_blog_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function art_blog_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'art-blog' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'art-blog' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'art-blog' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'art-blog' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'art-blog' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'art-blog' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'art-blog' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'art-blog' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'art_blog_widgets_init' );


function art_blog_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

// Font enqueue function
function art_blog_scripts() {
    // Google Fonts
    wp_enqueue_style(
        'art-blog-google-fonts',
        'https://fonts.googleapis.com/css2?family=Fjalla+One&family=PT+Sans:ital,wght@0,400;0,700;1,400;1,700&display=swap',
        array(),
        null
    );

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-5', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-5/css/all.min.css', array(), '5.15.3');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), '2.3.4');

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );

    // Main stylesheet
    wp_enqueue_style('art-blog-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Add custom inline styles safely
    $custom_style_path = get_parent_theme_file_path('/custom-style.php');
    if (file_exists($custom_style_path)) {
        require $custom_style_path;
        if (!empty($art_blog_custom_css)) {
            wp_add_inline_style('art-blog-style', $art_blog_custom_css);
        }
    }

    // RTL styles if needed
    wp_style_add_data('art-blog-style', 'rtl', 'replace');

    // Navigation script
    wp_enqueue_script('art-blog-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), '2.3.4', true);

    // Custom script
    wp_enqueue_script('art-blog-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'art_blog_scripts');

// related post
if (!function_exists('art_blog_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function art_blog_related_post($post_id){        
        $art_blog_categories = get_the_category($post_id);
        if ($art_blog_categories) {
            $art_blog_category_ids = array();
            $art_blog_category = get_category($art_blog_category_ids);
            $art_blog_categories = get_the_category($post_id);
            foreach ($art_blog_categories as $art_blog_category) {
                $art_blog_category_ids[] = $art_blog_category->term_id;
            }
            $count = $art_blog_category->category_count;
            if ($count > 1) { ?>

         	<?php
		$art_blog_related_post_wrap = absint(get_theme_mod('art_blog_enable_related_post', 1));
		if($art_blog_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('art_blog_related_post_text', __('Related Post', 'art-blog'))); ?></h2>
                    <?php
                    $art_blog_cat_post_args = array(
                        'category__in' => $art_blog_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'art_blog_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $art_blog_featured_query = new WP_Query($art_blog_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($art_blog_featured_query->have_posts()) :

                        while ($art_blog_featured_query->have_posts()) : $art_blog_featured_query->the_post();
                            ?>

                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php art_blog_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $art_blog_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/slider1.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $art_blog_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        art_blog_posted_on();
                                        art_blog_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('art_blog_related_posts', 'art_blog_related_post', 10, 1);

function art_blog_sanitize_choices( $art_blog_input, $art_blog_setting ) {
    global $wp_customize; 
    $art_blog_control = $wp_customize->get_control( $art_blog_setting->id ); 
    if ( array_key_exists( $art_blog_input, $art_blog_control->choices ) ) {
        return $art_blog_input;
    } else {
        return $art_blog_setting->default;
    }
}

//Excerpt 
function art_blog_excerpt_function($art_blog_excerpt_count = 35) {
    $art_blog_excerpt = get_the_excerpt();
    $art_blog_text_excerpt = wp_strip_all_tags($art_blog_excerpt);
    $art_blog_excerpt_limit = (int) get_theme_mod('art_blog_excerpt_limit', $art_blog_excerpt_count);
    $art_blog_words = preg_split('/\s+/', $art_blog_text_excerpt); 
    $art_blog_trimmed_words = array_slice($art_blog_words, 0, $art_blog_excerpt_limit);
    $art_blog_theme_excerpt = implode(' ', $art_blog_trimmed_words);

    return $art_blog_theme_excerpt;
}

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$art_blog_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function art_blog_sanitize_checkbox($art_blog_checked)
{
    // Boolean check.
    return ((isset($art_blog_checked) && true == $art_blog_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
    require get_template_directory() . '/revolution/inc/jetpack.php';
}

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function art_blog_enqueue_assets() {
    
    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/art_blog_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/art_blog_config_file.php';

    define('ART_BLOG_FREE_SUPPORT',__('https://wordpress.org/support/theme/art-blog/','art-blog'));
    define('ART_BLOG_PRO_SUPPORT',__('https://www.revolutionwp.com/support/revolution-wp/','art-blog'));
    define('ART_BLOG_REVIEW',__('https://wordpress.org/support/theme/art-blog/reviews/','art-blog'));
    define('ART_BLOG_BUY_NOW',__('https://www.revolutionwp.com/products/art-blog-wordpress-theme','art-blog'));
    define('ART_BLOG_LIVE_DEMO',__('https://demo.revolutionwp.com/art-blog-pro/','art-blog'));
    define('ART_BLOG_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/art-blog-pro/','art-blog'));
    define('ART_BLOG_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/art-blog-free/','art-blog'));

}
add_action( 'after_setup_theme', 'art_blog_enqueue_assets' );


function art_blog_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'art_blog_remove_customize_register', 11 );

/************************************************************************************/
// //////////////////////////////////////////////

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'art_blog_loop_columns');

if (!function_exists('art_blog_loop_columns')) {

	function art_blog_loop_columns() {

		$art_blog_columns = get_theme_mod( 'art_blog_per_columns', 3 );

		return $art_blog_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'art_blog_per_page', 20 );

function art_blog_per_page( $art_blog_cols ) {

  	$art_blog_cols = get_theme_mod( 'art_blog_product_per_page', 9 );

	return $art_blog_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'art_blog_products_args' );

function art_blog_products_args( $art_blog_args ) {

    $art_blog_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $art_blog_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $art_blog_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function art_blog_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --art_blog_logo_width: <?php echo absint(get_theme_mod('art_blog_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('art_blog_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'art_blog_custom_css' );

function art_blog_custom_css_for_slider() {
    $art_blog_slider_enabled = get_theme_mod('art_blog_enable_slider', false);
    if ($art_blog_slider_enabled) {
        echo '<style type="text/css">
            .page-template-revolution-home .header-menu-box {
                position: absolute;
                width: 100%;
                z-index: 999;
                background: transparent;
                border: none;
            }
        </style>';
    }
}
add_action('wp_head', 'art_blog_custom_css_for_slider');

// Add admin notice
function art_blog_admin_notice() { 
    global $pagenow;
    $art_blog_theme_args      = wp_get_theme();
    $art_blog_meta            = get_option( 'art_blog_admin_notice' );
    $name            = $art_blog_theme_args->__get( 'Name' );
    $art_blog_current_screen  = get_current_screen();

    if( !$art_blog_meta ){
        if( is_network_admin() ){
            return;
        }

        if( ! current_user_can( 'manage_options' ) ){
            return;
        } 
        
        if( $art_blog_current_screen->base !== 'appearance_page_art_blog_guide' && 
            $art_blog_current_screen->base !== 'toplevel_page_artblog-demoimport' ) { ?>

            <div class="notice notice-success art-blog-welcome-notice">
                <p class="art-blog-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'art_blog_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'art-blog' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="art-blog-welcome-notice-wrap">
                    <h2 class="art-blog-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $art_blog_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'art-blog' ), $art_blog_theme_name ) );
                        ?>
                    </h2>
                    <p class="art-blog-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'art-blog' ); ?>
                    </p>

                    <div class="art-blog-welcome-info">
                        <div class="art-blog-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'art-blog' ); ?>">
                        </div>

                        <div class="art-blog-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'art-blog' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'art-blog' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=artblog-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'art-blog' ); ?></a></p>
                        </div>

                        <div class="art-blog-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'art-blog' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'art-blog' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=art-blog-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'art-blog' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

    }
}

add_action( 'admin_notices', 'art_blog_admin_notice' );

if( ! function_exists( 'art_blog_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function art_blog_update_admin_notice(){
    if ( isset( $_GET['art_blog_admin_notice'] ) && $_GET['art_blog_admin_notice'] = '1' ) {
        update_option( 'art_blog_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'art_blog_update_admin_notice' );

add_action('after_switch_theme', 'art_blog_setup_options');
function art_blog_setup_options () {
    update_option('art_blog_admin_notice', FALSE );
}

// changelog
function art_blog_get_changelog_from_readme() {
    $file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($file_path)) {
        $content = file_get_contents($file_path);

        // Extract changelog section
        $changelog_start = strpos($content, "== Changelog ==");
        $changelog = substr($content, $changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $changelog, $matches, PREG_SET_ORDER);
        
        return $matches;
    }
    return [];
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );